"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProtocolBase = exports.ErrorProtocolProcessing = exports.ErrorIdleTimeout = exports.ErrorRaceFail = exports.DomainChannelStats = exports.CHANNEL_LOCAL = void 0;
exports.CHANNEL_LOCAL = 'local';
class DomainChannelStats {
    constructor(domain, port, dAndP, target, ttl) {
        this.updateAtMili = 0;
        this.pkgLostPct = -1;
        /** 0 means not tested yet */
        this.latency = 0;
        /** feedback latency from raceConnect */
        this.lastFeedbackLatency = 0;
        this.status = 'work';
        this.domain = domain;
        this.port = port;
        this.dAndP = dAndP;
        this.target = target;
        this.updateAtMili = Date.now();
        if (ttl === undefined)
            this.ttl = Infinity;
        else
            this.ttl = ttl;
    }
}
exports.DomainChannelStats = DomainChannelStats;
class ErrorRaceFail extends Error {
}
exports.ErrorRaceFail = ErrorRaceFail;
class ErrorIdleTimeout extends Error {
}
exports.ErrorIdleTimeout = ErrorIdleTimeout;
class ErrorProtocolProcessing extends Error {
}
exports.ErrorProtocolProcessing = ErrorProtocolProcessing;
class ProtocolBase {
    constructor(sock, connectFun, tranceId) {
        this.addr = '';
        this.port = 0;
        this.traceId = '';
        this.minCountShouldIdleTimeoutRecv = 0;
        this.sock = sock;
        this.connectFunc = connectFun;
        this.traceId = tranceId;
    }
    /**
     * If data need addon process, rewrite this method.
     */
    writeToTargetSock(data, targetSock, target) {
        targetSock.write(data);
    }
}
exports.ProtocolBase = ProtocolBase;
//# sourceMappingURL=types.js.map